/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ConfigClasses` (
  `id_class` int(10) unsigned NOT NULL auto_increment,
  `config_class` varchar(50) NOT NULL default '',
  `friendly_name` varchar(80) NOT NULL,
  `nav_visible` enum('yes','no') NOT NULL default 'yes',
  `ordering` int(11) NOT NULL default '0',
  `grouping` varchar(30) NOT NULL,
  `nav_links` varchar(512) NOT NULL,
  `nav_privs` enum('user','admin') NOT NULL default 'admin',
  `out_file` varchar(50) default NULL,
  `nagios_object` varchar(50) default NULL,
  PRIMARY KEY  (`id_class`)
) ENGINE=InnoDB AUTO_INCREMENT=16 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;
INSERT INTO `ConfigClasses` VALUES (1,'host','Hosts','yes',1,'','Show::overview.php?class=host;;Add::add_item.php?item=host','user','hosts.cfg','host'),(2,'hostgroup','Hostgroups','yes',2,'','Show::overview.php?class=hostgroup;;Add::add_item.php?item=hostgroup','user','hostgroups.cfg','hostgroup'),(3,'service','Services','yes',9,'','Show::overview.php?class=service;;Add::add_item.php?item=service','admin','services.cfg','service'),(4,'servicegroup','Servicegroups','yes',3,'','Show::overview.php?class=servicegroup;;Add::add_item.php?item=servicegroup','user','servicegroups.cfg','servicegroup'),(5,'contact','Contacts','yes',1,'','Show::overview.php?class=contact;;Add::add_item.php?item=contact','admin','contacts.cfg','contact'),(6,'contactgroup','Contactgroups','yes',2,'','Show::overview.php?class=contactgroup;;Add::add_item.php?item=contactgroup','admin','contactgroups.cfg','contactgroup'),(7,'timeperiod','Timeperiods','yes',10,'','Show::overview.php?class=timeperiod;;Add::add_item.php?item=timeperiod','admin','timeperiods.cfg','timeperiod'),(8,'checkcommand','Checkcommands','yes',7,'','Show::overview.php?class=checkcommand;;Add::add_item.php?item=checkcommand','admin','checkcommands.cfg','command'),(9,'os','OS','yes',3,'','Show::overview.php?class=os;;Add::add_item.php?item=os','admin',NULL,NULL),(10,'nagios-collector','Nagios-collectors','yes',1,'Nagios servers','Show::overview.php?class=nagios-collector;;Add::add_item.php?item=nagios-collector','admin',NULL,NULL),(11,'nagios-monitor','Nagios-monitors','yes',0,'Nagios servers','Show::overview.php?class=nagios-monitor;;Add::add_item.php?item=nagios-monitor','admin',NULL,NULL),(12,'host-preset','Host presets','yes',11,'','Show::overview.php?class=host-preset;;Add::add_item.php?item=host-preset','admin',NULL,NULL),(13,'misccommand','Misccommands','yes',8,'','Show::overview.php?class=misccommand;;Add::add_item.php?item=misccommand','admin','misccommands.cfg','command'),(14,'host-template','Host templates','yes',12,'','Show::overview.php?class=host-template;;Add::add_item.php?item=host-template','admin','host_templates.cfg','host'),(15,'service-template','Service templates','yes',13,'','Show::overview.php?class=service-template;;Add::add_item.php?item=service-template','admin','service_templates.cfg','service');
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ConfigAttrs` (
  `id_attr` int(10) unsigned NOT NULL auto_increment,
  `attr_name` varchar(60) NOT NULL default '',
  `friendly_name` varchar(80) NOT NULL default '',
  `description` varchar(250) default NULL,
  `datatype` enum('text','password','select','assign_one','assign_many','assign_cust_order') NOT NULL default 'text',
  `max_length` int(11) default NULL,
  `poss_values` text,
  `predef_value` varchar(1024) default NULL,
  `mandatory` enum('yes','no') NOT NULL default 'no',
  `ordering` int(11) NOT NULL default '0',
  `visible` enum('yes','no') NOT NULL default 'yes',
  `write_to_conf` enum('yes','no') NOT NULL default 'yes',
  `naming_attr` enum('yes','no') NOT NULL default 'no',
  `link_as_child` enum('yes','no') NOT NULL default 'no',
  `fk_show_class_items` int(10) unsigned default NULL,
  `fk_id_class` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id_attr`),
  KEY `fk_show_class_items` (`fk_show_class_items`),
  KEY `fk_id_class` (`fk_id_class`),
  CONSTRAINT `ConfigAttrs_ibfk_1` FOREIGN KEY (`fk_show_class_items`) REFERENCES `ConfigClasses` (`id_class`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `ConfigAttrs_ibfk_2` FOREIGN KEY (`fk_id_class`) REFERENCES `ConfigClasses` (`id_class`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=158 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;
INSERT INTO `ConfigAttrs` VALUES (1,'server_name','server name',NULL,'text',255,'','','yes',1,'yes','no','yes','no',NULL,10),(2,'active_checks_enabled','active checking',NULL,'select',0,'0::1','','no',4,'yes','yes','no','no',NULL,10),(3,'passive_checks_enabled','passive checking',NULL,'select',0,'0::1','','no',5,'yes','yes','no','no',NULL,10),(4,'notifications_enabled','notification enabled',NULL,'select',0,'0::1','','no',6,'yes','yes','no','no',NULL,10),(5,'check_freshness','check freshness',NULL,'select',0,'0::1','','no',7,'yes','yes','no','no',NULL,10),(6,'server_name','server name',NULL,'text',255,'','','yes',1,'yes','no','yes','no',NULL,11),(7,'active_checks_enabled','active checking',NULL,'select',0,'0::1','','no',7,'yes','yes','no','no',NULL,11),(8,'passive_checks_enabled','passive checking',NULL,'select',0,'0::1','','no',8,'yes','yes','no','no',NULL,11),(9,'notifications_enabled','notification enabled',NULL,'select',0,'0::1','','no',9,'yes','yes','no','no',NULL,11),(10,'check_freshness','check freshness',NULL,'select',0,'0::1','','no',10,'yes','yes','no','no',NULL,11),(11,'freshness_threshold','freshness threshold',NULL,'text',5,'','','no',11,'yes','yes','no','no',NULL,11),(12,'icon_image_alt','OS description',NULL,'text',255,'','','yes',1,'yes','yes','yes','no',NULL,9),(13,'icon_image','icon image','img/logos/...','text',255,'','base/linux40.gif','no',2,'yes','yes','no','no',NULL,9),(14,'statusmap_image','statusmap image','img/logos/...','text',255,'','base/linux40.gd2','no',3,'yes','yes','no','no',NULL,9),(15,'host_name','hostname',NULL,'text',255,'','','yes',1,'yes','yes','yes','no',NULL,1),(16,'alias','alias','alias or FQDN','text',255,'','','no',2,'yes','yes','no','no',NULL,1),(17,'address','IP-address',NULL,'text',255,'','','yes',3,'yes','yes','no','no',NULL,1),(18,'os','OS','','assign_one',0,'','Linux','yes',4,'yes','no','no','no',9,1),(19,'check_period','check period','time period to run checks','assign_one',0,'','24x7','no',9,'yes','yes','no','no',7,1),(20,'notification_period','notification period','time period to alarm','assign_one',0,'','24x7','no',10,'yes','yes','no','no',7,1),(22,'contact_groups','contact groups','responsible group','assign_many',0,'','','no',12,'yes','yes','no','no',6,1),(23,'parents','parent hosts','host dependency','assign_many',0,'','','no',14,'yes','yes','no','no',1,1),(24,'notes','notes',NULL,'text',1024,'','','no',15,'yes','yes','no','no',NULL,1),(25,'notes_url','notes URL',NULL,'text',1024,'','','no',16,'yes','yes','no','no',NULL,1),(26,'monitored_by','monitored by','monitoring server (empty = not monitored)','assign_one',0,'','','no',6,'yes','no','no','no',10,1),(27,'hostgroup_name','hostgroup name',NULL,'text',255,'','','yes',1,'yes','yes','yes','no',NULL,2),(28,'alias','alias',NULL,'text',255,'','','yes',2,'yes','yes','no','no',NULL,2),(29,'members','hostgroup members',NULL,'assign_many',0,'','','no',3,'yes','yes','no','yes',1,2),(30,'command_name','check command name',NULL,'text',255,'','','yes',1,'yes','yes','yes','no',NULL,8),(31,'command_line','check command line',NULL,'text',1024,'','','yes',3,'yes','yes','no','no',NULL,8),(32,'timeperiod_name','timeperiod name',NULL,'text',255,'','','yes',1,'yes','yes','yes','no',NULL,7),(33,'alias','alias',NULL,'text',255,'','','no',2,'yes','yes','no','no',NULL,7),(34,'sunday','sunday timeperiod','00:00-24:00','text',255,'','','no',3,'yes','yes','no','no',NULL,7),(35,'monday','monday timeperiod','00:00-24:00','text',255,'','','no',4,'yes','yes','no','no',NULL,7),(36,'tuesday','tuesday timeperiod','00:00-24:00','text',255,'','','no',5,'yes','yes','no','no',NULL,7),(37,'wednesday','wednesday timeperiod','00:00-24:00','text',255,'','','no',6,'yes','yes','no','no',NULL,7),(38,'thursday','thursday timeperiod','00:00-24:00','text',255,'','','no',7,'yes','yes','no','no',NULL,7),(39,'friday','friday timeperiod','00:00-24:00','text',255,'','','no',8,'yes','yes','no','no',NULL,7),(40,'saturday','saturday timeperiod','00:00-24:00','text',255,'','','no',9,'yes','yes','no','no',NULL,7),(41,'max_check_attempts','max check attempts',NULL,'text',4,'','','no',12,'yes','no','no','no',NULL,7),(43,'check_interval','check interval',NULL,'text',4,'','','no',13,'yes','no','no','no',NULL,7),(44,'retry_interval','retry interval',NULL,'text',4,'','','no',14,'yes','no','no','no',NULL,7),(45,'notification_interval','notification interval',NULL,'text',4,'','','no',15,'yes','no','no','no',NULL,7),(46,'host_notification_options','host notification options',NULL,'text',20,'','','no',16,'yes','no','no','no',NULL,7),(47,'contact_name','contact name','username','text',255,'','','yes',1,'yes','yes','yes','no',NULL,5),(48,'alias','alias','firstname lastname','text',255,'','','yes',2,'yes','yes','no','no',NULL,5),(49,'host_notification_period','host notification period','host alarming timeperiod','assign_one',0,'','','no',3,'yes','yes','no','no',7,5),(50,'service_notification_period','service notification period','service alarming timeperiod','assign_one',0,'','','no',4,'yes','yes','no','no',7,5),(51,'host_notification_options','host notification options','possible values: d,u,r,f,[n]','text',255,'','d','no',5,'yes','yes','no','no',NULL,5),(52,'service_notification_options','service notification options','possible values: w,u,c,r,f,[n]','text',255,'','c','no',6,'yes','yes','no','no',NULL,5),(53,'host_notification_commands','host notification commands','default: notify-host-by-email','assign_many',0,'','notify-host-by-email','no',7,'yes','yes','no','no',13,5),(54,'service_notification_commands','service notification commands','default: notify-service-by-email','assign_many',0,'','notify-service-by-email','no',8,'yes','yes','no','no',13,5),(55,'email','e-mail address',NULL,'text',255,'','','yes',9,'yes','yes','no','no',NULL,5),(56,'pager','pager','(country code) + (prefix) + (number)','text',255,'','','no',10,'yes','yes','no','no',NULL,5),(57,'contactgroup_name','contactgroup name',NULL,'text',255,'','','yes',1,'yes','yes','yes','no',NULL,6),(58,'alias','alias',NULL,'text',255,'','','yes',2,'yes','yes','no','no',NULL,6),(59,'members','contactgroup members',NULL,'assign_many',0,'','','no',3,'yes','yes','no','yes',5,6),(60,'service_description','service name',NULL,'text',255,'','','yes',1,'yes','yes','yes','no',NULL,3),(61,'check_command','check command',NULL,'assign_one',0,'','','yes',2,'yes','yes','no','no',8,3),(62,'host_name','assigned to host',NULL,'assign_one',0,'','','yes',3,'yes','yes','no','no',1,3),(63,'check_period','check period','time period to run checks','assign_one',0,'','24x7','no',5,'yes','yes','no','no',7,3),(64,'notification_period','notification period','time period to alarm','assign_one',0,'','','no',6,'yes','yes','no','no',7,3),(65,'contact_groups','contact groups','responsible group','assign_many',0,'','','no',7,'yes','yes','no','no',6,3),(67,'notes','notes',NULL,'text',1024,'','','no',8,'yes','yes','no','no',NULL,3),(68,'notes_url','notes URL',NULL,'text',1024,'','','no',9,'yes','yes','no','no',NULL,3),(69,'event_handler_enabled','event-handler enabled',NULL,'select',0,'0::1','0','no',11,'no','yes','no','no',NULL,3),(70,'servicegroup_name','servicegroup name',NULL,'text',255,'','','yes',1,'yes','yes','yes','no',NULL,4),(71,'alias','alias',NULL,'text',255,'','','yes',2,'yes','yes','no','no',NULL,4),(72,'members','servicegroup members',NULL,'assign_many',0,'','','no',3,'yes','yes','no','yes',3,4),(73,'template_name','host preset name',NULL,'text',255,'','','yes',1,'yes','no','yes','no',NULL,12),(74,'command_name','host preset commands','checks to be pre-selected for new hosts','assign_many',0,'','','yes',3,'yes','no','no','yes',8,12),(75,'host-preset','host preset','predefined services / host-alive check','assign_one',0,'','linux-server','yes',5,'yes','no','no','no',12,1),(79,'check_params','params for check command',NULL,'text',1024,'','!','no',12,'yes','no','no','no',NULL,3),(81,'hostalive_check','host-alive check','','assign_one',0,'','check-host-alive','yes',2,'yes','yes','no','no',13,12),(86,'command_syntax','command description','describe the command syntax','text',1024,'','ARG1=...,ARG2=...,ARG3=...','no',4,'yes','no','no','no',NULL,8),(87,'default_params','default command params','separated by \"!\"','text',1024,'','!','no',5,'yes','no','no','no',NULL,8),(88,'service_notification_options','service notification options',NULL,'text',20,'','','no',17,'yes','no','no','no',NULL,7),(90,'freshness_threshold','freshness threshold',NULL,'text',5,'','','no',8,'yes','yes','no','no',NULL,10),(91,'collector_check_freshness','check freshness (of collectors)','value is applied to all services of collector hosts','select',0,'0::1','1','yes',2,'yes','no','no','no',NULL,11),(92,'collector_freshness_threshold','freshness threshold (of collectors)','value is applied to \"check_ssh\" services of collector hosts','text',5,'','900','yes',3,'yes','no','no','no',NULL,11),(93,'host_is_collector','host is collector','is this host a collector itself?','select',0,'no::yes','no','yes',7,'yes','no','no','no',NULL,1),(94,'command_param_count','amount of params','','select',0,'1::2::3::4::5::6::7::8::9::10','1','yes',6,'yes','no','no','no',NULL,8),(95,'user_password','user password','password for NConf & Nagios GUI','password',255,'','','no',11,'no','no','no','no',NULL,5),(96,'nc_permission','nconf permissions','defines the permissions in NConf','select',0,'no access::user::admin','user','no',12,'no','no','no','no',NULL,5),(97,'nagios_access','nagios access','defines access to the Nagios GUI','select',0,'enabled::disabled','enabled','no',13,'no','no','no','no',NULL,5),(98,'command_name','misc command name','','text',255,'','','yes',1,'yes','yes','yes','no',NULL,13),(99,'command_line','misc command line','','text',1024,'','','yes',2,'yes','yes','no','no',NULL,13),(101,'action_url','action URL','PNP URL (if installed), NConf dependency view, or both','select',0,'/nagios/html/pnp4nagios/index.php?host=$HOSTNAME$::https://URL_TO_NCONF/dependency.php?xmode=nagiosview&hostname=$HOSTNAME$&service_link=https://URL_TO_NAGIOS/nagios/cgi-bin/extinfo.cgi::https://URL_TO_NCONF/dependency.php?xmode=nagiosview&hostname=$HOSTNAME$&service_link=https://URL_TO_NAGIOS/nagios/cgi-bin/extinfo.cgi&pnp_link=https://URL_TO_NAGIOS/nagios/html/pnp4nagios/index.php','','no',17,'yes','yes','no','no',NULL,1),(102,'action_url','action URL','PNP URL (if installed)','select',0,'/nagios/html/pnp4nagios/index.php?host=$HOSTNAME$&srv=$SERVICEDESC$','','no',10,'yes','yes','no','no',NULL,3),(103,'default_service_name','default service name','default name to use for new services','text',255,NULL,NULL,'no',2,'yes','no','no','no',NULL,8),(104,'notes','notes',NULL,'text',1024,NULL,NULL,'no',4,'yes','yes','no','no',NULL,2),(105,'notes_url','notes URL',NULL,'text',1024,NULL,NULL,'no',5,'yes','yes','no','no',NULL,2),(106,'notes','notes',NULL,'text',1024,NULL,NULL,'no',4,'yes','yes','no','no',NULL,4),(107,'notes_url','notes URL',NULL,'text',1024,NULL,NULL,'no',5,'yes','yes','no','no',NULL,4),(108,'name','template name','','text',255,'','','yes',1,'yes','yes','yes','no',NULL,14),(109,'host_name','host name','mandatory if \"register\" = 1','text',255,'','','no',2,'no','no','no','no',NULL,14),(110,'register','register','display this template as a host in Nagios','select',0,'0::1','0','yes',3,'no','yes','no','no',NULL,14),(111,'check_period','check period','time period to run checks','assign_one',0,'','','no',4,'yes','yes','no','no',7,14),(112,'notification_period','notification period','time period to alarm','assign_one',0,'','','no',5,'yes','yes','no','no',7,14),(113,'check_command','check command','host-alive check','assign_one',0,'','','no',6,'yes','yes','no','no',13,14),(114,'use','parent template(s)','parent template(s) to inherit from','assign_cust_order',0,'','','no',7,'yes','yes','no','no',14,14),(115,'contact_groups','contact groups','responsible group','assign_many',0,'','','no',8,'yes','yes','no','no',6,14),(116,'notes','notes',NULL,'text',1024,'','','no',9,'yes','yes','no','no',NULL,14),(117,'notes_url','notes URL',NULL,'text',1024,'','','no',10,'yes','yes','no','no',NULL,14),(118,'action_url','action URL','PNP URL (if installed)','select',0,'/nagios/html/pnp4nagios/index.php?host=$HOSTNAME$::https://URL_TO_NCONF/dependency.php?xmode=nagiosview&hostname=$HOSTNAME$&service_link=https://URL_TO_NAGIOS/nagios/cgi-bin/extinfo.cgi::https://URL_TO_NCONF/dependency.php?xmode=nagiosview&hostname=$HOSTNAME$&service_link=https://URL_TO_NAGIOS/nagios/cgi-bin/extinfo.cgi&pnp_link=https://URL_TO_NAGIOS/nagios/html/pnp4nagios/index.php','','no',11,'yes','yes','no','no',NULL,14),(119,'max_check_attempts','max check attempts','number of times to retry checking','text',4,'','','no',12,'yes','yes','no','no',NULL,14),(120,'check_interval','check interval','number of [min.] between regularly scheduled checks','text',4,'','','no',13,'yes','yes','no','no',NULL,14),(121,'retry_interval','retry interval','number of [min.] to wait before scheduling a re-check','text',4,'','','no',14,'yes','yes','no','no',NULL,14),(122,'notification_interval','notification interval','number of [min.] to wait before re-notifying a contact','text',4,'','','no',15,'yes','yes','no','no',NULL,14),(123,'notification_options','notification options','possible values: d,u,r,f,s,[n]','text',20,'','','no',16,'yes','yes','no','no',NULL,14),(124,'active_checks_enabled','active checking','do active checking of hosts','select',0,'0::1','','no',17,'yes','yes','no','no',NULL,14),(125,'passive_checks_enabled','passive checking','do passive checking of hosts','select',0,'0::1','','no',18,'yes','yes','no','no',NULL,14),(126,'notifications_enabled','notification enabled','send notifications for hosts','select',0,'0::1','','no',19,'yes','yes','no','no',NULL,14),(127,'check_freshness','check freshness','check age of last check results','select',0,'0::1','','no',20,'yes','yes','no','no',NULL,14),(128,'freshness_threshold','freshness threshold','age threshold in [sec.]','text',5,'','','no',21,'yes','yes','no','no',NULL,14),(129,'name','template name','','text',255,'','','yes',1,'yes','yes','yes','no',NULL,15),(130,'service_description','service name','mandatory if \"register\" = 1','text',255,'','','no',2,'no','no','no','no',NULL,15),(131,'register','register','display this template as a service in Nagios','select',0,'0::1','0','yes',3,'no','yes','no','no',NULL,15),(132,'check_period','check period','time period to run checks','assign_one',0,'','','no',4,'yes','yes','no','no',7,15),(133,'notification_period','notification period','time period to alarm','assign_one',0,'','','no',5,'yes','yes','no','no',7,15),(134,'use','parent template(s)','parent template(s) to inherit from','assign_cust_order',0,'','','no',6,'yes','yes','no','no',15,15),(135,'contact_groups','contact groups','responsible group','assign_many',0,'','','no',7,'yes','yes','no','no',6,15),(136,'notes','notes',NULL,'text',1024,'','','no',8,'yes','yes','no','no',NULL,15),(137,'notes_url','notes URL',NULL,'text',1024,'','','no',9,'yes','yes','no','no',NULL,15),(138,'action_url','action URL','PNP URL (if installed)','select',0,'/nagios/html/pnp4nagios/index.php?host=$HOSTNAME$&srv=$SERVICEDESC$','','no',10,'yes','yes','no','no',NULL,15),(139,'max_check_attempts','max check attempts','number of times to retry checking','text',4,'','','no',11,'yes','yes','no','no',NULL,15),(140,'check_interval','check interval','number of [min.] between regularly scheduled checks','text',4,'','','no',12,'yes','yes','no','no',NULL,15),(141,'retry_interval','retry interval','number of [min.] to wait before scheduling a re-check','text',4,'','','no',13,'yes','yes','no','no',NULL,15),(142,'notification_interval','notification interval','number of [min.] to wait before re-notifying a contact','text',4,'','','no',14,'yes','yes','no','no',NULL,15),(143,'notification_options','notification options','possible values: w,u,c,r,f,s,[n]','text',20,'','','no',15,'yes','yes','no','no',NULL,15),(144,'active_checks_enabled','active checking','do active checking of services','select',0,'0::1','','no',16,'yes','yes','no','no',NULL,15),(145,'passive_checks_enabled','passive checking','do passive checking of services','select',0,'0::1','','no',17,'yes','yes','no','no',NULL,15),(146,'notifications_enabled','notification enabled','send notifications for services','select',0,'0::1','','no',18,'yes','yes','no','no',NULL,15),(147,'check_freshness','check freshness','check age of last check results','select',0,'0::1','','no',19,'yes','yes','no','no',NULL,15),(148,'freshness_threshold','freshness threshold','age threshold in [sec.]','text',5,'','','no',20,'yes','yes','no','no',NULL,15),(149,'use','host template(s)','host template(s) to inherit properties from','assign_cust_order',NULL,NULL,NULL,'no',8,'yes','yes','no','no',14,1),(150,'use','service template(s)','service template(s) to inherit properties from','assign_cust_order',NULL,NULL,NULL,'no',4,'yes','yes','no','no',15,3),(151,'host_template','host template(s)','add the following template(s) to all hosts monitored by this server','assign_cust_order',NULL,NULL,'Default_collector_server','no',2,'yes','no','no','no',14,10),(152,'service_template','service template(s)','add the following template(s) to all services monitored by this server','assign_cust_order',NULL,NULL,'Default_collector_server','no',3,'yes','no','no','no',15,10),(153,'stale_service_command','stale service command','\"dummy\" command to run for stale services','assign_one',NULL,NULL,'service_is_stale','no',4,'yes','no','no','no',13,11),(154,'host_template','host template(s)','add the following template(s) to all hosts monitored by this server','assign_cust_order',NULL,NULL,'Default_monitor_server','no',5,'yes','no','no','no',14,11),(155,'service_template','service template(s)','add the following template(s) to all services monitored by this server','assign_cust_order',NULL,NULL,'Default_monitor_server','no',6,'yes','no','no','no',15,11),(156,'host_template','host template(s)','add the following template(s) to all hosts linked with this timeperiod','assign_cust_order',NULL,NULL,'','no',10,'yes','no','no','no',14,7),(157,'service_template','service template(s)','add the following template(s) to all services linked with this timeperiod','assign_cust_order',NULL,NULL,'','no',11,'yes','no','no','no',15,7);
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ConfigItems` (
  `id_item` int(10) unsigned NOT NULL auto_increment,
  `fk_id_class` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id_item`),
  KEY `fk_id_class` (`fk_id_class`),
  CONSTRAINT `ConfigItems_ibfk_1` FOREIGN KEY (`fk_id_class`) REFERENCES `ConfigClasses` (`id_class`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=5305 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;
INSERT INTO `ConfigItems` VALUES (5260,1),(5268,1),(5278,1),(5289,1),(5267,2),(5270,2),(5273,2),(5280,2),(5261,3),(5262,3),(5263,3),(5264,3),(5265,3),(5266,3),(5269,3),(5274,3),(5279,3),(5290,3),(5275,4),(5253,5),(5226,6),(9,7),(10,7),(11,7),(5228,8),(5229,8),(5230,8),(5238,8),(5239,8),(5240,8),(5241,8),(5242,8),(5243,8),(5244,8),(5245,8),(5246,8),(5247,8),(5248,8),(5249,8),(5250,8),(5251,8),(5252,8),(5,9),(7,9),(2528,9),(5254,9),(5255,9),(5256,9),(5257,9),(5277,9),(1,10),(5231,12),(5258,12),(5259,12),(5276,12),(5291,13),(5292,13),(5293,13),(5294,13),(5295,13),(5296,13),(5297,14),(5298,14),(5299,14),(5300,14),(5301,15),(5302,15),(5303,15),(5304,15);
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ConfigValues` (
  `attr_value` varchar(1024) default NULL,
  `fk_id_attr` int(10) unsigned NOT NULL default '0',
  `fk_id_item` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`fk_id_attr`,`fk_id_item`),
  KEY `fk_id_item` (`fk_id_item`),
  CONSTRAINT `ConfigValues_ibfk_1` FOREIGN KEY (`fk_id_attr`) REFERENCES `ConfigAttrs` (`id_attr`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `ConfigValues_ibfk_2` FOREIGN KEY (`fk_id_item`) REFERENCES `ConfigItems` (`id_item`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;
INSERT INTO `ConfigValues` VALUES ('Default Nagios',1,1),('1',2,1),('0',3,1),('1',4,1),('0',5,1),('Linux',12,5),('Windows Server',12,7),('Sun Solaris',12,2528),('HP Unix',12,5254),('Free BSD',12,5255),('Router',12,5256),('Switch',12,5257),('HP Printer',12,5277),('base/linux40.gif',13,5),('base/win40.gif',13,7),('base/sunlogo.gif',13,2528),('base/hpux.gif',13,5254),('base/freebsd40.gif',13,5255),('base/router40.gif',13,5256),('base/switch40.gif',13,5257),('base/hp-printer40.gif',13,5277),('base/linux40.gd2',14,5),('base/win40.gd2',14,7),('base/sunlogo.gd2',14,2528),('base/hpux.gd2',14,5254),('base/freebsd40.gd2',14,5255),('base/router40.gd2',14,5256),('base/switch40.gd2',14,5257),('base/hp-printer40.gd2',14,5277),('localhost',15,5260),('winserver',15,5268),('hplj2605dn',15,5278),('linksys-srw224p',15,5289),('localhost.localdomain',16,5260),('winserver.localdomain',16,5268),('HP LaserJet 2605dn',16,5278),('Linksys SRW224P Switch',16,5289),('127.0.0.1',17,5260),('192.168.1.2',17,5268),('192.168.1.30',17,5278),('192.168.1.253',17,5289),('',24,5260),('',24,5268),('',24,5278),('',24,5289),('',25,5260),('',25,5268),('',25,5278),('',25,5289),('linux-servers',27,5267),('windows-servers',27,5270),('switches',27,5273),('network-printers',27,5280),('Linux Servers',28,5267),('Windows Servers',28,5270),('Network Switches',28,5273),('Network Printers',28,5280),('check_local_disk',30,5228),('check_local_load',30,5229),('check_local_procs',30,5230),('check_local_users',30,5238),('check_local_swap',30,5239),('check_local_mrtgtraf',30,5240),('check_ftp',30,5241),('check_hpjd',30,5242),('check_snmp',30,5243),('check_http',30,5244),('check_ssh',30,5245),('check_ping',30,5246),('check_pop',30,5247),('check_imap',30,5248),('check_smtp',30,5249),('check_tcp',30,5250),('check_udp',30,5251),('check_nt',30,5252),('$USER1$/check_disk -w $ARG1$ -c $ARG2$ -p $ARG3$',31,5228),('$USER1$/check_load -w $ARG1$ -c $ARG2$',31,5229),('$USER1$/check_procs -w $ARG1$ -c $ARG2$ -s $ARG3$',31,5230),('$USER1$/check_users -w $ARG1$ -c $ARG2$',31,5238),('$USER1$/check_swap -w $ARG1$ -c $ARG2$',31,5239),('$USER1$/check_mrtgtraf -F $ARG1$ -a $ARG2$ -w $ARG3$ -c $ARG4$ -e $ARG5$',31,5240),('$USER1$/check_ftp -H $HOSTADDRESS$ $ARG1$',31,5241),('$USER1$/check_hpjd -H $HOSTADDRESS$ $ARG1$',31,5242),('$USER1$/check_snmp -H $HOSTADDRESS$ $ARG1$',31,5243),('$USER1$/check_http -I $HOSTADDRESS$ $ARG1$',31,5244),('$USER1$/check_ssh $ARG1$ $HOSTADDRESS$',31,5245),('$USER1$/check_ping -H $HOSTADDRESS$ -w $ARG1$ -c $ARG2$ -p 5',31,5246),('$USER1$/check_pop -H $HOSTADDRESS$ $ARG1$',31,5247),('$USER1$/check_imap -H $HOSTADDRESS$ $ARG1$',31,5248),('$USER1$/check_smtp -H $HOSTADDRESS$ $ARG1$',31,5249),('$USER1$/check_tcp -H $HOSTADDRESS$ -p $ARG1$ $ARG2$',31,5250),('$USER1$/check_udp -H $HOSTADDRESS$ -p $ARG1$ $ARG2$',31,5251),('$USER1$/check_nt -H $HOSTADDRESS$ -p 12489 -v $ARG1$ $ARG2$',31,5252),('24x7',32,9),('workhours',32,10),('none',32,11),('24 Hours A Day, 7 Days A Week',33,9),('Normal Work Hours',33,10),('No Time Is A Good Time',33,11),('00:00-24:00',34,9),('',34,10),('',34,11),('00:00-24:00',35,9),('09:00-17:00',35,10),('',35,11),('00:00-24:00',36,9),('09:00-17:00',36,10),('',36,11),('00:00-24:00',37,9),('09:00-17:00',37,10),('',37,11),('00:00-24:00',38,9),('09:00-17:00',38,10),('',38,11),('00:00-24:00',39,9),('09:00-17:00',39,10),('',39,11),('00:00-24:00',40,9),('',40,10),('',40,11),('3',41,9),('5',41,10),('5',41,11),('5',43,9),('10',43,10),('10',43,11),('1',44,9),('2',44,10),('2',44,11),('15',45,9),('15',45,10),('15',45,11),('d,u,r',46,9),('d,u,r',46,10),('d,u,r',46,11),('nagiosadmin',47,5253),('Nagios Admin',48,5253),('d,u,r,f,n',51,5253),('w,u,c,r,f,n',52,5253),('nagios@localhost',55,5253),('',56,5253),('admins',57,5226),('Nagios Administrators',58,5226),('check_local_disk',60,5261),('check_local_load',60,5262),('check_local_mrtgtraf',60,5263),('check_local_procs',60,5264),('check_local_swap',60,5265),('check_local_users',60,5266),('check_nt',60,5269),('check_http',60,5274),('check_hpjd',60,5279),('check_snmp',60,5290),('web-services',70,5275),('Web Services',71,5275),('linux-server',73,5231),('windows-server',73,5258),('generic-switch',73,5259),('generic-printer',73,5276),('!3!5!/',79,5261),('!5!10',79,5262),('!',79,5263),('!2!3!X,Z',79,5264),('!95%!90%',79,5265),('!5!10',79,5266),('!',79,5269),('!',79,5274),('!',79,5279),('!',79,5290),('ARG1=Warn level,ARG2=Critical level,ARG3=Path or partition',86,5228),('ARG1=Warn level,ARG2=Critical Level',86,5229),('ARG1=Warn level,ARG2=Critical level,ARG3=Status flags (DRSTWXZ)',86,5230),('ARG1=Warn level,ARG2=Critical Level',86,5238),('ARG1=Warn level,ARG2=Critical Level',86,5239),('ARG1=Log file,ARG2=Aggregation (AVG|MAX),ARG3=Warn level,ARG4=Critical level,ARG5=Expires (min)',86,5240),('ARG1=Multiple options',86,5241),('ARG1=Multiple options',86,5242),('ARG1=Multiple options',86,5243),('ARG1=Multiple options',86,5244),('ARG1=Multiple options',86,5245),('ARG1=Warn level,ARG2=Critical Level',86,5246),('ARG1=Multiple options',86,5247),('ARG1=Multiple options',86,5248),('ARG1=Multiple options',86,5249),('ARG1=Port,ARG2=Multiple options',86,5250),('ARG1=Port,ARG2=Multiple options',86,5251),('ARG1=Variable to check,ARG2=Multiple options',86,5252),('!3!5!/',87,5228),('!5!10',87,5229),('!2!3!X,Z',87,5230),('!5!10',87,5238),('!95%!90%',87,5239),('!',87,5240),('!',87,5241),('!',87,5242),('!',87,5243),('!',87,5244),('!',87,5245),('!20,80%!30,90%',87,5246),('!',87,5247),('!',87,5248),('!',87,5249),('!',87,5250),('!',87,5251),('!',87,5252),('w,u,c,r',88,9),('w,u,c,r',88,10),('w,u,c,r',88,11),('86400',90,1),('yes',93,5260),('no',93,5268),('no',93,5278),('no',93,5289),('3',94,5228),('2',94,5229),('3',94,5230),('2',94,5238),('2',94,5239),('5',94,5240),('1',94,5241),('1',94,5242),('1',94,5243),('1',94,5244),('1',94,5245),('2',94,5246),('1',94,5247),('1',94,5248),('1',94,5249),('2',94,5250),('2',94,5251),('2',94,5252),('user',96,5253),('enabled',97,5253),('notify-host-by-email',98,5291),('notify-service-by-email',98,5292),('check-host-alive',98,5293),('process-host-perfdata',98,5294),('process-service-perfdata',98,5295),('service_is_stale',98,5296),('/usr/bin/printf \"%b\" \"***** Nagios *****\\n\\nNotification Type: $NOTIFICATIONTYPE$\\nHost: $HOSTNAME$\\nState: $HOSTSTATE$\\nAddress: $HOSTADDRESS$\\nInfo: $HOSTOUTPUT$\\n\\nDate/Time: $LONGDATETIME$\\n\" | /bin/mail -s \"** $NOTIFICATIONTYPE$ Host Alert: $HOSTNAME$ is $HOSTSTATE$ **\" $CONTACTEMAIL$',99,5291),('/usr/bin/printf \"%b\" \"***** Nagios *****\\n\\nNotification Type: $NOTIFICATIONTYPE$\\n\\nService: $SERVICEDESC$\\nHost: $HOSTALIAS$\\nAddress: $HOSTADDRESS$\\nState: $SERVICESTATE$\\n\\nDate/Time: $LONGDATETIME$\\n\\nAdditional Info:\\n\\n$SERVICEOUTPUT$\" | /bin/mail -s \"** $NOTIFICATIONTYPE$ Service Alert: $HOSTALIAS$/$SERVICEDESC$ is $SERVICESTATE$ **\" $CONTACTEMAIL$',99,5292),('$USER1$/check_ping -H $HOSTADDRESS$ -w 3000.0,80% -c 5000.0,100% -p 5',99,5293),('/usr/bin/printf \"%b\" \"$LASTHOSTCHECK$\\t$HOSTNAME$\\t$HOSTSTATE$\\t$HOSTATTEMPT$\\t$HOSTSTATETYPE$\\t$HOSTEXECUTIONTIME$\\t$HOSTOUTPUT$\\t$HOSTPERFDATA$\\n\" >> /var/nagios/host-perfdata.out',99,5294),('/usr/bin/printf \"%b\" \"$LASTSERVICECHECK$\\t$HOSTNAME$\\t$SERVICEDESC$\\t$SERVICESTATE$\\t$SERVICEATTEMPT$\\t$SERVICESTATETYPE$\\t$SERVICEEXECUTIONTIME$\\t$SERVICELATENCY$\\t$SERVICEOUTPUT$\\t$SERVICEPERFDATA$\\n\" >> /var/nagios/service-perfdata.out',99,5295),('/usr/lib/nagios/plugins/eventhandlers/stale_service.sh',99,5296),('Default_collector_server',108,5297),('Default_monitor_server',108,5298),('Default_timeperiod_interval_5',108,5299),('Default_timeperiod_interval_10',108,5300),('0',110,5297),('0',110,5298),('0',110,5299),('0',110,5300),('3',119,5299),('5',119,5300),('5',120,5299),('10',120,5300),('1',121,5299),('2',121,5300),('15',122,5299),('15',122,5300),('d,u,r',123,5299),('d,u,r',123,5300),('1',124,5297),('0',124,5298),('0',125,5297),('1',125,5298),('1',126,5297),('1',126,5298),('0',127,5297),('0',127,5298),('86400',128,5297),('86400',128,5298),('Default_collector_server',129,5301),('Default_monitor_server',129,5302),('Default_timeperiod_interval_5',129,5303),('Default_timeperiod_interval_10',129,5304),('0',131,5301),('0',131,5302),('0',131,5303),('0',131,5304),('3',139,5303),('5',139,5304),('5',140,5303),('10',140,5304),('1',141,5303),('2',141,5304),('15',142,5303),('15',142,5304),('w,u,c,r',143,5303),('w,u,c,r',143,5304),('1',144,5301),('0',144,5302),('0',145,5301),('1',145,5302),('1',146,5301),('1',146,5302),('0',147,5301),('0',147,5302),('86400',148,5301),('86400',148,5302);
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ItemLinks` (
  `fk_id_item` int(10) unsigned NOT NULL default '0',
  `fk_item_linked2` int(10) unsigned NOT NULL default '0',
  `fk_id_attr` int(10) unsigned NOT NULL default '0',
  `cust_order` int(11) NOT NULL default '0',
  PRIMARY KEY  (`fk_id_item`,`fk_item_linked2`,`fk_id_attr`),
  KEY `fk_item_linked2` (`fk_item_linked2`),
  KEY `fk_id_attr` (`fk_id_attr`),
  CONSTRAINT `ItemLinks_ibfk_1` FOREIGN KEY (`fk_id_item`) REFERENCES `ConfigItems` (`id_item`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `ItemLinks_ibfk_2` FOREIGN KEY (`fk_item_linked2`) REFERENCES `ConfigItems` (`id_item`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `ItemLinks_ibfk_3` FOREIGN KEY (`fk_id_attr`) REFERENCES `ConfigAttrs` (`id_attr`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;
INSERT INTO `ItemLinks` VALUES (5231,5293,81,0),(5242,5276,74,0),(5243,5259,74,0),(5245,5231,74,0),(5252,5258,74,0),(5253,9,49,0),(5253,9,50,0),(5253,5226,59,0),(5253,5291,53,0),(5253,5292,54,0),(5258,5293,81,0),(5259,5293,81,0),(5260,1,26,0),(5260,5,18,0),(5260,9,19,0),(5260,9,20,0),(5260,5226,22,0),(5260,5231,75,0),(5260,5267,29,0),(5260,5289,23,0),(5261,9,63,0),(5261,9,64,0),(5261,5226,65,0),(5261,5228,61,0),(5261,5260,62,0),(5262,9,63,0),(5262,9,64,0),(5262,5226,65,0),(5262,5229,61,0),(5262,5260,62,0),(5263,9,63,0),(5263,9,64,0),(5263,5226,65,0),(5263,5240,61,0),(5263,5260,62,0),(5264,9,63,0),(5264,9,64,0),(5264,5226,65,0),(5264,5230,61,0),(5264,5260,62,0),(5265,9,63,0),(5265,9,64,0),(5265,5226,65,0),(5265,5239,61,0),(5265,5260,62,0),(5266,9,63,0),(5266,9,64,0),(5266,5226,65,0),(5266,5238,61,0),(5266,5260,62,0),(5268,7,18,0),(5268,9,19,0),(5268,9,20,0),(5268,5226,22,0),(5268,5258,75,0),(5268,5270,29,0),(5268,5289,23,0),(5269,9,63,0),(5269,9,64,0),(5269,5226,65,0),(5269,5252,61,0),(5269,5268,62,0),(5274,9,63,0),(5274,9,64,0),(5274,5226,65,0),(5274,5244,61,0),(5274,5260,62,0),(5274,5275,72,0),(5276,5293,81,0),(5278,9,19,0),(5278,9,20,0),(5278,5226,22,0),(5278,5276,75,0),(5278,5277,18,0),(5278,5280,29,0),(5278,5289,23,0),(5279,9,63,0),(5279,9,64,0),(5279,5226,65,0),(5279,5242,61,0),(5279,5278,62,0),(5289,9,19,0),(5289,9,20,0),(5289,5226,22,0),(5289,5257,18,0),(5289,5259,75,0),(5290,9,63,0),(5290,9,64,0),(5290,5226,65,0),(5290,5243,61,0),(5290,5289,62,0);
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `History` (
  `id_hist` int(10) unsigned NOT NULL auto_increment,
  `timestamp` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `user_str` varchar(250) NOT NULL,
  `action` enum('created','added','assigned','unassigned','modified','removed','general') NOT NULL,
  `attr_name` varchar(80) NOT NULL,
  `attr_value` varchar(1024) default NULL,
  `fk_id_item` int(10) unsigned default NULL,
  PRIMARY KEY  (`id_hist`),
  KEY `fk_id_item` (`fk_id_item`),
  CONSTRAINT `History_ibfk_1` FOREIGN KEY (`fk_id_item`) REFERENCES `ConfigItems` (`id_item`) ON DELETE SET NULL ON UPDATE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=3891 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;
